<?php

/**
 * @file
 * Views integration for the Quant module.
 */

/**
 * Implements hook_views_data().
 */
function quant_views_data() {

  // Basic table information.
  $data['quant_log']['table']['group'] = t('Quant Log');
  $data['quant_log']['table']['base'] = array(
    'field' => 'id',
    'title' => t('Quant Log'),
    'help' => t('Log of most recent seed activity.'),
    'weight' => 10,
  );

  // Log item id.
  $data['quant_log']['id'] = array(
    'title' => t('ID'),
    'help' => t('The autogenerated id of the log item.'),
    'field' => array(
      'handler' => 'views_handler_field',
      'click sortable' => TRUE,
    ),
    'sort' => array(
      'handler' => 'views_handler_sort',
    ),
    'filter' => array(
      'handler' => 'views_handler_filter_numeric',
    ),
  );

  // Log item entity id.
  $data['quant_log']['entity_id'] = array(
    'title' => t('Entity ID'),
    'help' => t('The entity id of the log item, if applicable.'),
    'field' => array(
      'handler' => 'views_handler_field',
      'click sortable' => TRUE,
    ),
    'sort' => array(
      'handler' => 'views_handler_sort',
    ),
    'filter' => array(
      'handler' => 'views_handler_filter_numeric',
    ),
  );

  // Log item url.
  $data['quant_log']['url'] = array(
    'title' => t('URL'),
    'help' => t('The url of the seed item, e.g. "http://localhost/node/123".'),
    'field' => array(
      'handler' => 'views_handler_field_url',
      'click sortable' => TRUE,
    ),
    'sort' => array(
      'handler' => 'views_handler_sort',
    ),
    'filter' => array(
      'handler' => 'views_handler_filter_string',
    ),
    'argument' => array(
      'handler' => 'views_handler_argument_string',
    ),
  );

  // Log item static url.
  $data['quant_log']['static_url'] = array(
    'title' => t('Static URL'),
    'help' => t('The static url of the seed item, e.g. "http://www.example.com/node/123".'),
    'field' => array(
      'handler' => 'views_handler_field_quant_static_url',
    ),
  );

  // Log item type.
  $data['quant_log']['type'] = array(
    'title' => t('Type'),
    'help' => t('The type of the seed item, e.g. "node", "redirect", "sitemap", etc.'),
    'field' => array(
      'handler' => 'views_handler_field',
      'click sortable' => TRUE,
    ),
    'sort' => array(
      'handler' => 'views_handler_sort',
    ),
    'filter' => array(
      'handler' => 'views_handler_filter_string',
    ),
    'argument' => array(
      'handler' => 'views_handler_argument_string',
    ),
  );

  // Log item status.
  $data['quant_log']['status'] = array(
    'title' => t('Status'),
    'help' => t('The response status of the seed item, e.g. "200", "301", "404", etc.'),
    'field' => array(
      'handler' => 'views_handler_field',
      'click sortable' => TRUE,
    ),
    'sort' => array(
      'handler' => 'views_handler_sort',
    ),
    'filter' => array(
      'handler' => 'views_handler_filter_string',
    ),
    'argument' => array(
      'handler' => 'views_handler_argument_string',
    ),
  );

  // Log item updated timestamp.
  $data['quant_log']['updated'] = array(
    'title' => t('Updated'),
    'help' => t('The updated timestamp of the seed item.'),
    'field' => array(
      'handler' => 'views_handler_field_date',
      'click sortable' => TRUE,
    ),
    'sort' => array(
      'handler' => 'views_handler_sort',
    ),
    'filter' => array(
      'handler' => 'views_handler_filter_date',
    ),
    'argument' => array(
      'handler' => 'views_handler_argument_date',
    ),
  );

  // Log item hash.
  $data['quant_log']['hash'] = array(
    'title' => t('Hash'),
    'help' => t('The hash of the seed item.'),
    'field' => array(
      'handler' => 'views_handler_field',
      'click sortable' => TRUE,
    ),
    'sort' => array(
      'handler' => 'views_handler_sort',
    ),
    'filter' => array(
      'handler' => 'views_handler_filter_string',
    ),
    'argument' => array(
      'handler' => 'views_handler_argument_string',
    ),
  );

  // Log item md5.
  $data['quant_log']['md5'] = array(
    'title' => t('MD5'),
    'help' => t('The md5 of the seed item.'),
    'field' => array(
      'handler' => 'views_handler_field',
      'click sortable' => TRUE,
    ),
    'sort' => array(
      'handler' => 'views_handler_sort',
    ),
    'filter' => array(
      'handler' => 'views_handler_filter_string',
    ),
    'argument' => array(
      'handler' => 'views_handler_argument_string',
    ),
  );

  // Log item message.
  $data['quant_log']['message'] = array(
    'title' => t('Log Message'),
    'help' => t('The log message for the seed item.'),
    'field' => array(
      'handler' => 'views_handler_field',
      'click sortable' => TRUE,
    ),
    'sort' => array(
      'handler' => 'views_handler_sort',
    ),
    'filter' => array(
      'handler' => 'views_handler_filter_string',
    ),
    'argument' => array(
      'handler' => 'views_handler_argument_string',
    ),
  );

  return $data;
}
